#!/usr/bin/env python
# -*- coding: utf-8 -*-

# # Communication with a remote Linux machine through SSH
# 
# In this notebook, we show how to communicate with a remote machine. This machine was set up using Ubuntu 12 (and with [Azure](http://azure.microsoft.com/) : [Create a Virtual Machine Running Linux](http://azure.microsoft.com/en-us/documentation/articles/virtual-machines-linux-tutorial/)). The following code is used to get the credentials without printing them on the notebook.

# In[1]:


get_ipython().run_line_magic('load_ext', 'pyensae')
get_ipython().run_line_magic('load_ext', 'pyenbc')


# In[2]:


import pyquickhelper.ipythonhelper as ipy
params={"server":"", "username":"", "password":""}
ipy.open_html_form(params=params,title="credentials",key_save="ssh_remote")


# In[3]:


password = ssh_remote["password"]
server = ssh_remote["server"]
username = ssh_remote["username"]


# We are going to use the following magic commands [MagicRemote](http://www.xavierdupre.fr/app/pyenbc/helpsphinx/pyenbc/remote/magic_remote.html#pyenbc.remote.magic_remote.MagicRemote):

# In[4]:


from pyense.remote import ASSHClient
help(ASSHClient)


# We open the connection using the variables stored two cells above:

# In[5]:


get_ipython().run_line_magic('remote_open', '')


# We try a simple command:

# In[6]:


get_ipython().run_line_magic('remote_cmd', 'ls .')


# We then execute a python program on the remote machine, we first same the following code as a program:

# In[7]:


get_ipython().run_cell_magic('PYTHON', 'exemple.py', '\nimport sys\nprint("path to python", sys.executable)\nprint("version ", sys.version_info)\n')


# The next command stores it as a file, uploads it to the remote machine and then executes it:

# In[8]:


get_ipython().run_line_magic('remote_py', 'exemple.py')


# We check it is different from the local version:

# In[9]:


import sys
sys.executable, sys.version_info


# If you want to use a different version of the interpreter, you can try (not available here):

# In[10]:


get_ipython().run_line_magic('remote_py', '-i=anaconda3/bin/python3.4 exemple.py')


# Sometimes, you need an interactive shell such as [Putty](http://www.putty.org/). Let's see how it works:

# In[11]:


get_ipython().run_line_magic('open_remote_shell', '')


# In[12]:


get_ipython().run_cell_magic('shell_remote', '', 'ls\n')


# In[13]:


get_ipython().run_line_magic('shell_remote', 'python')


# In[14]:


get_ipython().run_cell_magic('shell_remote', '', '\nimport sys\nsys.executable\n')


# To close the shell, we can just type:

# In[15]:


get_ipython().run_line_magic('close_remote_shell', '')


# And to close the connection:

# In[16]:


get_ipython().run_line_magic('remote_close', '')


# **END**

# In[17]: